use axum::{
    http::StatusCode,
    response::{IntoResponse, Response},
};
use thiserror::Error;

#[derive(Error, Debug)]
pub enum AppError {
    #[error("Authentication required")]
    Unauthorized,

    #[error("Forbidden")]
    Forbidden,

    #[error("User not found")]
    UserNotFound,

    #[error("Invalid credentials")]
    InvalidCredentials,

    #[error("Database error")]
    DbError(#[from] sea_orm::DbErr),

    #[error("Validierungsfehler: {0}")]
    ValidationError(#[from] validator::ValidationErrors),

    #[error("Fehler in .env")]
    Err(#[from] std::env::VarError),
}

impl IntoResponse for AppError {
    fn into_response(self) -> Response {
        let status = match self {
            AppError::Unauthorized => StatusCode::UNAUTHORIZED,
            AppError::Forbidden => todo!(),
            AppError::UserNotFound => todo!(),
            AppError::InvalidCredentials => todo!(),
            AppError::ValidationError(_) => todo!(),
            AppError::Err(_) => todo!(),
            AppError::DbError(db_err) => todo!(),
            // ... weitere Matches
        };
        (status, self.to_string()).into_response()
    }
}
