use serde::{Deserialize, Serialize};
use uuid::Uuid;
use validator::Validate;

#[derive(Debug, Serialize, Deserialize, Validate)]
pub struct ErstelleBenutzer {
    #[validate(length(min = 10, max = 255))]
    pub email: String,

    #[validate(length(min = 8, max = 8))]
    pub kennung: String,

    #[validate(length(max = 100))]
    pub nachname: String,

    #[validate(length(max = 100))]
    pub vorname: String,
}

#[derive(Debug, Serialize, Deserialize, Validate)]
pub struct AktualisiereBenutzer {
    pub id: Uuid,

    #[validate(length(min = 10, max = 255))]
    pub e_mail: Option<String>,

    #[validate(length(min = 8, max = 8))]
    pub kennung: Option<String>,

    #[validate(length(max = 100))]
    pub nachname: Option<String>,

    #[validate(length(max = 100))]
    pub vorname: Option<String>,

    pub ist_aktiv: Option<bool>,
}

#[derive(Debug, Deserialize)]
pub struct LoescheBenutzer {
    pub id: Uuid,
}
