use std::env;

use axum::Json;
use database::repository::benutzer::BenutzerRepository;
use database::{error::AppError, model::benutzer::ErstelleBenutzer};
use sea_orm::Database;

#[tokio::main]
async fn main() -> Result<(), AppError> {
    dotenvy::dotenv().unwrap();

    let db = Database::connect(env::var("DATABASE_URL").unwrap()).await?;

    // Service initialisieren
    let user_service = BenutzerRepository::new(db);

    let benutzer = ErstelleBenutzer {
        kennung: "12345243".into(),
        nachname: "Doe".into(),
        vorname: "John".into(),
        email: "222H2@example.com".into(),
    };

    let b = user_service.create_user(Json(benutzer)).await?;
    println!("{:?}", b);

    Ok(())
}
